Name:           mmlib
Version:        1.4.2
%global so_version 1
Release:    2%{?dist}
Summary:        OS abstraction layer and helpers

License:        Apache-2.0
URL:            https://opensource.mindmaze.com/projects/mmlib
%global forgeurl https://github.com/mmlabs-mindmaze/mmlib
Source0:         %{forgeurl}/archive/%{version}/mmlib-%{version}.tar.gz

Patch0:         0001-Fix-getaddrinfo_valid-ask-for-SOCK_STREAM.patch
Patch1:         0002-Fix-getaddrinfo_error-ask-for-SOCK_RAW.patch
Patch2:         0003-Work-around-create_invalid_sockclient-test-failure.patch
Patch4:         0004-Omit-the-getaddrinfo_error-test.patch

Patch100:       0001-Skip-the-wait_signal-test.patch

ExcludeArch:    %{ix86}

BuildRequires:  meson
BuildRequires:  gcc
BuildRequires:  python3-devel

BuildRequires:  pkgconfig(check)


BuildRequires:  gettext

%global common_description %{expand:
mmlib is an Operating System abstraction layer.

It provides an API for application developer, so that they can write portable
code using relatively advanced OS features without having to care about system
specifics.

The reference design in mind in its conception is POSIX, meaning that if some
posix functionality is not available for given platform, mmlib will implement
that same functionality itself.}

%description %{common_description}


%package devel
Summary:        Development files for mmlib
Requires:       mmlib = %{version}-%{release}

%description devel %{common_description}

The mmlib-devel package contains libraries and header files for developing
applications that use mmlib.


%prep
%autosetup -N
%autopatch -p1 -M 99
%ifarch %{arm64} ppc64le
%autopatch -p1 -m 100 -M 199
%endif
%py3_shebang_fix read_version.py


%build
%meson -Dtests=enabled -Ddocs=disabled -Dnls=enabled
%meson_build


%install
%meson_install
%find_lang %{name}


%check
%global _smp_build_ncpus 1
%meson_test


%files -f %{name}.lang
%license LICENSE
%doc README.md
%doc TODO.md

%{_libdir}/libmmlib.so.%{so_version}{,.*}


%files devel
%doc doc/examples/

%{_libdir}/libmmlib.so

%{_libdir}/pkgconfig/mmlib.pc

%{_includedir}/mmargparse.h
%{_includedir}/mmdlfcn.h
%{_includedir}/mmerrno.h
%{_includedir}/mmlib.h
%{_includedir}/mmlog.h
%{_includedir}/mmpredefs.h
%{_includedir}/mmprofile.h
%{_includedir}/mmsysio.h
%{_includedir}/mmthread.h
%{_includedir}/mmtime.h


%changelog
* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 1.4.2-2
- Rebuilt for loongarch64

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.4.2-1
- initial build
